    //#New(backend): Y                                                //- [Y]  if new (backend) to add
    //#Init_Base:    sMQTTBroker()                                                //- parameter to add at launch of library in case of backend
    //#Init_Include: bool init(uint16_t port, bool checkWifiConnection=false)                                                //- function added at initialization (it can be Loop_Base)
    //#Loop_Base:                                                    //- function launched at loop start and activation callback function on event
    //#Loop1_Event:                                                  //- event to monitor in a loop
    //#Loop1_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop2_Event:                                                  //- event to monitor in a loop
    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop3_Event:                                                  //- event to monitor in a loop
    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#CallBack1_Base:                                               //- callback on arduino side
    //#CallBack1_Config: SubVoid_BArray 0 MessageArrivedSub          //- CallbackType Par1 EndPar callbacksub
    //#CallBack2_Base:                                               //- callback on arduino side
    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#CallBack3_Base:                                               //- callback on arduino side
    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#

#include "B4RDefines.h"
#include "rsMQTTBroker.h"
  
    bool FullsMQTTBroker::onEvent(sMQTTEvent *event)
    {   switch(event->Type())
        { 
        case LostConnect_sMQTTEventType:
            {
               B4R::B4RsMQTTBroker::onLostConnectEvent();
            }  
        }      
      if (B4R::B4RsMQTTBroker::Tracesactive) {
        switch(event->Type())
        {
        case NewClient_sMQTTEventType:
            {
                sMQTTNewClientEvent *e=(sMQTTNewClientEvent*)event;
                std::string Log= e->Login();
                std::string Pas= e->Password();              
                uint32_t Cli = reinterpret_cast<uint32_t>(e->Client());                 
                Serial.print("Event_New Client : ");Serial.print(Cli); Serial.print(" User : "); Serial.print(Log.c_str()); Serial.print(" Password : "); Serial.println(Pas.c_str());

            }
            break;
        case RemoveClient_sMQTTEventType:
            {
                sMQTTRemoveClientEvent *e=(sMQTTRemoveClientEvent*)event;
                uint32_t Cli = reinterpret_cast<uint32_t>(e->Client());
                Serial.print("Event_Client Removed : ");Serial.println(Cli);
            }
            break;                
        case Public_sMQTTEventType:
            {
                sMQTTPublicClientEvent *e=(sMQTTPublicClientEvent*)event;
                std::string Top = e->Topic();
                std::string Pay = e->Payload();
                uint32_t Cli = reinterpret_cast<uint32_t>(e->Client());
                Serial.print("Event_Client Publish : ");Serial.print(Cli);Serial.print(" Topic : "); Serial.print(Top.c_str()); Serial.print(" Payload: "); Serial.println(Pay.c_str());
    
            }
            break;               
        case UnSubscribe_sMQTTEventType:
            {
                sMQTTSubUnSubClientEvent *e=(sMQTTSubUnSubClientEvent*)event;
                std::string Top = e->Topic();
                uint32_t Cli = reinterpret_cast<uint32_t>(e->Client());
                Serial.print("Event_UnSubscribe : ");Serial.print(Cli);Serial.print(" Topic : "); Serial.println(Top.c_str());             
            }
            break;      
        case Subscribe_sMQTTEventType:
            {
                sMQTTSubUnSubClientEvent *e=(sMQTTSubUnSubClientEvent*)event;
                std::string Top = e->Topic();
                uint32_t Cli = reinterpret_cast<uint32_t>(e->Client()); 
                Serial.print("Event_Subscribe : ");Serial.print(Cli);Serial.print(" Topic : "); Serial.println(Top.c_str());              
            }
            break;
        }
       
    }  return true;
    };

namespace B4R
{
    B4RsMQTTBroker*  B4RsMQTTBroker::instance = NULL;
    bool B4RsMQTTBroker::Tracesactive = false;
    
    void B4RsMQTTBroker::Initialize(uint16_t port, bool checkWifiConnection, Subvoid_void OnLostConnectSub)
    { 
       rcs = new (backend) FullsMQTTBroker();
       rcs->init(port, checkWifiConnection);
       this->OnLostConnectSub = OnLostConnectSub;
       instance = this;
    };
        
    void B4RsMQTTBroker::activeTraces(bool traces)
    {
        Tracesactive = traces;
    };            

    void B4RsMQTTBroker::update()
    {
       rcs->update();
    };

    void B4RsMQTTBroker::publish(B4RString* topic, B4RString* payload, byte qos, bool retain)
    {              
       rcs->publish(topic->data, payload->data, qos, retain);      
    };

    void B4RsMQTTBroker::restart()
    {
       rcs->restart();
    };

    uint32_t B4RsMQTTBroker::getRetainedTopicCount()
    {
       return rcs->getRetainedTopicCount();
    };
    
    B4RString* B4RsMQTTBroker::getRetaiedTopicName(uint32_t index)
    {
       std::string rax = rcs->getRetaiedTopicName(index); char* raw = (char*) rax.c_str();      
       B4RString* arr = CreateStackMemoryObject(B4RString);
       arr->data = raw;
       return arr;       
    };
       
    void B4RsMQTTBroker::onLostConnectEvent()
    {
       instance->OnLostConnectSub();
    };

}
