    //#New(backend): Y                                                //- [Y]  if new (backend) to add
    //#Init_Base:    sMQTTBroker()                                                //- parameter to add at launch of library in case of backend
    //#Init_Include: bool init(uint16_t port, bool checkWifiConnection=false)                                                //- function added at initialization (it can be Loop_Base)
    //#Loop_Base:                                                    //- function launched at loop start and activation callback function on event
    //#Loop1_Event:                                                  //- event to monitor in a loop
    //#Loop1_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop2_Event:                                                  //- event to monitor in a loop
    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop3_Event:                                                  //- event to monitor in a loop
    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#CallBack1_Base:                                               //- callback on arduino side
    //#CallBack1_Config: SubVoid_BArray 0 MessageArrivedSub          //- CallbackType Par1 EndPar callbacksub
    //#CallBack2_Base:                                               //- callback on arduino side
    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#CallBack3_Base:                                               //- callback on arduino side
    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#

#pragma once
#include "B4RDefines.h"
#include "sMQTTBroker.h"

//~hide
class FullsMQTTBroker : public sMQTTBroker
{
   public:
      bool onEvent(sMQTTEvent *event) override;
};      

    //~Event: onLostConnectEvent()
    //~Version: 1.0 
    //~Author - 
    //~Libray from https://github.com/terrorsl/sMQTTBroker

namespace B4R {
    typedef void (*Subvoid_void)(void);
    //~shortname:sMQTTBroker
    class B4RsMQTTBroker
    {
        private:
            uint8_t backend[sizeof(FullsMQTTBroker)];
            FullsMQTTBroker* rcs;
            static B4RsMQTTBroker* instance;
            Subvoid_void OnLostConnectSub;
        public: 
    //~hide
            static bool Tracesactive;
	// setup broker            
            void Initialize(uint16_t port, bool checkWifiConnection, Subvoid_void OnLostConnectSub);
   // Unactivate or Activate traces on events
            void activeTraces(bool traces);
	// call in loop function         
            void update();
	// publish message            
            void publish(B4RString* topic, B4RString* payload, byte qos, bool retain);
	// restart WIFI server            
            void restart();
	// get retained topic count            
            uint32_t getRetainedTopicCount();
	// get topic name by index            
            B4RString* getRetaiedTopicName(uint32_t index);
         
            static void onLostConnectEvent();
            
            #define /*byte Qos0;*/ B4RQoS0                                      0
            #define /*byte QoS1;*/ B4RQoS1                                      1
            #define /*byte QoS2;*/ B4RQoS2                                      2
            #define /*byte QoS3;*/ B4RQoS3                                      3
            
    };
}
